IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'ATUALIZA_PARCMPSUP_PDR' AND
            TYPE = 'P'                  AND
            U.UID = O.UID               AND
            U.NAME = USER)
   DROP PROCEDURE ATUALIZA_PARCMPSUP_PDR
GO

CREATE
PROCEDURE ATUALIZA_PARCMPSUP_PDR
   @P_CDFILIAL   VARCHAR(4)
AS
   DECLARE @V_UPDATE_TEXT             NVARCHAR(4000);
   DECLARE @V_INSERT_TEXT             NVARCHAR(4000);
   DECLARE @V_CDFILIAL_PADRAO         VARCHAR(4);
   DECLARE @V_CDFILIAL                VARCHAR(4);
   DECLARE @V_NAME                    VARCHAR(50);
   DECLARE @V_CDFILIALREL             VARCHAR(4);
BEGIN
   BEGIN TRANSACTION;
   SELECT @V_CDFILIAL_PADRAO = MAX(CDFILIPADRAO)
   FROM PARAMGERAL;
   /*VERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF (@V_CDFILIAL_PADRAO) IS NOT NULL BEGIN
      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO DA TABELA 'PARCMPSUP'*/
      DECLARE C_INSPARAM CURSOR FOR
         (SELECT CDFILIAL
            FROM PARAMFILIPADR
           WHERE IDTABPARAMFILI = 'S'
             AND NMTABPARAMFILI = 'PARCMPSUP'
             AND CDFILIAL <> @V_CDFILIAL_PADRAO
             AND CDFILIAL = ISNULL(@P_CDFILIAL, CDFILIAL));
      OPEN C_INSPARAM;
      FETCH NEXT FROM C_INSPARAM INTO
      @V_CDFILIAL

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_UPDATE_TEXT = 'INSERT INTO PARCMPSUP (';
         SET @V_INSERT_TEXT = '(SELECT ';

         /*APAGA AS EMPRESAS DA FILIAL QUE SERA PARAMETRIZADA*/
         DELETE FROM EMPRCNTRFIL WHERE CDFILIAL = @V_CDFILIAL;

         /*CADASTRA EMRESAS NA FILIAL QUE SERA PARAMETRIZADA */
         SELECT @V_CDFILIALREL = MAX(CDFILIAL)
           FROM EMPRCNTRFIL
          WHERE CDFILIAL = @V_CDFILIAL_PADRAO;

         IF @V_CDFILIALREL IS NOT NULL BEGIN
            INSERT INTO EMPRCNTRFIL (CDFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDSERIE)
                                    (SELECT @V_CDFILIAL, CDEMPRESA,
                                            CDINSCESTA, CDINSCMUNI, CDSERIE
                                       FROM EMPRCNTRFIL
                                      WHERE CDFILIAL = @V_CDFILIAL_PADRAO)
         END

         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PARCMPSUP'*/

         DECLARE C_CAMPO CURSOR FOR (SELECT C.NAME
                                       FROM SYSOBJECTS O, SYSCOLUMNS C
                                      WHERE O.ID = C.ID
                                        AND O.NAME = 'PARCMPSUP'
                                        AND C.NAME <> 'CDFILIAL')
         OPEN C_CAMPO;
         FETCH NEXT FROM C_CAMPO INTO
            @V_NAME
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_UPDATE_TEXT = @V_UPDATE_TEXT +@V_NAME+  ', ';
            SET @V_INSERT_TEXT = @V_INSERT_TEXT +@V_NAME+  ', ';
            FETCH NEXT FROM C_CAMPO INTO
            @V_NAME
         END;
         CLOSE C_CAMPO;
         DEALLOCATE C_CAMPO;
         /*DELETA A OS PARAMETROS DA FILIAL QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PARCMPSUP
         WHERE CDFILIAL = @V_CDFILIAL;


         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT+ 'CDFILIAL) ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT+ '''' +@V_CDFILIAL+''''+' ';

         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'FROM PARCMPSUP ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'WHERE CDFILIAL = '+'''' +@V_CDFILIAL_PADRAO+ '''' + ')';
         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT + @V_INSERT_TEXT;

         EXECUTE SP_EXECUTESQL @V_UPDATE_TEXT;

         FETCH NEXT FROM C_INSPARAM INTO
         @V_CDFILIAL;
      END;
      CLOSE C_INSPARAM;
      DEALLOCATE C_INSPARAM;
   END;
   COMMIT TRANSACTION;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_PARCMPSUP_PDR','5.07.006';
GO
