/******************************************************************************/
/* SISTEMAS INTEGRADOS TECNISA                                                */
/*                                                                            */
/* COMPRAS E SUPRIMENTOS                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* NOME: 8730_CMPTRGS_AJUSTE_CONTAPAGAR_NF                                    */
/*                                                                            */
/* @C:\web_565\sql\end_conv\sqlserver\8730_CMPTRGS_AJUSTE_CONTAPAGAR_NF.SQL;  */
/*                                                                            */
/* DESCRIO:                                                                 */
/* REAJUSTA A CONTA A PAGAR PREVISTA DE ACORDO COM O RESTANTE A SER ENTREGUE  */
/*                                                                            */
/* CRIAO:                                                                   */
/* 26/11/03 - JOAO FERNANDO DOS REIS CORREA                                   */
/*                                                                            */
/* ALTERAO:                                                                 */
/* 15/10/12 - MRCIO JOS DA SILVA LIMA                                       */
/*                                                                            */
/* RAISERROR('', 16,1);                                                       */
/*                                                                            */
/******************************************************************************/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'AJUSTE_CONTAPAGAR_NF'  and
            type = 'P'                       and
            u.uid = o.uid                    and
            u.name = USER)

   DROP PROCEDURE AJUSTE_CONTAPAGAR_NF;
GO

CREATE PROCEDURE AJUSTE_CONTAPAGAR_NF
   @P_CDFILIAL   VARCHAR(4),
   @P_NRLANCTONF VARCHAR(10),
   @P_IDSTATUS   VARCHAR(1)

AS

DECLARE  @V_IDSTATUSAUX         VARCHAR(1);
DECLARE  @V_IDGERCONTPGT        VARCHAR(1);

/*DECLARE VARIAVEL DO CURSOR  C_NOTAREAL */
DECLARE  @V_IDENTRSAIDOP        VARCHAR(1);
DECLARE  @V_CDFORNECED          VARCHAR(21);

/*DECLARE VARIAVEL DO CURSOR  C_AUTOFORNE */
DECLARE  @V_CDFILDEST           VARCHAR(4);
DECLARE  @V_CDFILLANC           VARCHAR(4);
DECLARE  @V_NRAUTOFORN          VARCHAR(10);

/*DECLARE VARIAVEL DO CURSOR C_NOTAPREVISTA */
DECLARE @V_NRLANCTONF           VARCHAR(10);
DECLARE @V_DTPROGENTAF          DATETIME;

/*DECLARE CURSOR C_DESCPREVISTA */
DECLARE @V_VRORIGPAG            DOUBLE PRECISION;
DECLARE @V_VRATUAPAG            DOUBLE PRECISION;
DECLARE @V_NRSEQVENPAG          NUMERIC;

/*DECLARE CURSOR C_DESCNOTA */
DECLARE @V_NRSEQVENPAGDESC      NUMERIC;
DECLARE @V_VRORIGPAGDESC        DOUBLE PRECISION;
DECLARE @V_VRATUAPAGDESC        DOUBLE PRECISION;

/*DECLARE CURSOR C_DESCNOTA */
DECLARE @V_CDEMPRESA            VARCHAR(2);
DECLARE @V_CDCLASSFINA          VARCHAR(6);
DECLARE @V_DTMOVFLUXO           DATETIME;
DECLARE @V_IDMOVFLUXO           VARCHAR(1);

/*DECLARE CURSOR C_ORCAFINA */
DECLARE  @V_CDEMPRESAOF         VARCHAR(2);
DECLARE  @V_CDFILIALOF          VARCHAR(4);
DECLARE  @V_CDCLASSFINAOF       VARCHAR(6);
DECLARE  @V_DTORCAFINAOF        DATETIME;

DECLARE @V_VALORDEVOLVIDO       DOUBLE PRECISION;
DECLARE @V_DIFERENCA            DOUBLE PRECISION;
DECLARE @V_VRORIGPAGFLUX        DOUBLE PRECISION;
DECLARE @V_VRORIGPAGAUX         DOUBLE PRECISION;

DECLARE @V_TESTE                DOUBLE PRECISION;
DECLARE @V_VRREALORCAAUX        DOUBLE PRECISION;

DECLARE @V_TOTITM_VRDESC        NUMERIC;
DECLARE @V_VRATUAPAGAUX         NUMERIC;
DECLARE @V_CDFILLANCAUX         VARCHAR(4);
DECLARE @V_CDFILDESTAUX         VARCHAR(4);
DECLARE @V_NRAUTOFORNAUX        VARCHAR(10);
DECLARE @V_NRLANCTONFAUX        VARCHAR(10);
DECLARE @V_NRSEQVENPAGFLUX      NUMERIC;

DECLARE  @V_IDCONSORCFIN        VARCHAR(1);
DECLARE  @V_IDTPORCAFINA        VARCHAR(1);
DECLARE  @V_CDFILIAL            VARCHAR(4);

DECLARE @V_DTPROGENTAFAUX       DATETIME;

DECLARE @V_COUNT                NUMERIC;

BEGIN

   DECLARE C_NOTAREAL CURSOR FOR
   SELECT IDENTRSAIDOP,  CDFORNECED
     FROM NOTAFISCAL
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF

   OPEN C_NOTAREAL;
   FETCH NEXT FROM C_NOTAREAL INTO @V_IDENTRSAIDOP, @V_CDFORNECED;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_IDENTRSAIDOP = 'E') AND (@V_CDFORNECED IS NOT NULL) BEGIN /* SE A NOTA FOR DE ENTRADA DE FORNEDCEDOR */
         IF (@P_IDSTATUS IN ('E', 'A')) BEGIN
            SELECT @V_IDGERCONTPGT = MAX(IDGERCONTPGT)
              FROM FORNECEDOR
             WHERE CDFORNECED = @V_CDFORNECED;

            IF @V_IDGERCONTPGT = 'S' BEGIN      
               DECLARE C_AUTOFORNE CURSOR FOR  /* PEGA AS AF'S RELACIONADAS  NOTA */
                  SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN
                    FROM NFRELACAF
                   WHERE CDFILIAL   = @P_CDFILIAL
                     AND NRLANCTONF = @P_NRLANCTONF
               OPEN C_AUTOFORNE;
               FETCH NEXT FROM C_AUTOFORNE INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_CDFILLANCAUX  = @V_CDFILLANC;
                  SET @V_CDFILDESTAUX  = @V_CDFILDEST;
                  SET @V_NRAUTOFORNAUX = @V_NRAUTOFORN;

                  DECLARE C_NOTAPREVISTA CURSOR FOR   /* PEGA O NUMERO DE LANAMENTO DA NOTA DA AF */
                  SELECT DISTINCT NRLANCTONF, DTPROGENTAF
                    FROM ITEMAUTF
                   WHERE CDFILLANC  = @V_CDFILLANC
                     AND CDFILDEST  = @V_CDFILDEST
                     AND NRAUTOFORN = @V_NRAUTOFORN

                  OPEN C_NOTAPREVISTA;
                  FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     SET @V_NRLANCTONFAUX  = @V_NRLANCTONF;
                     SET @V_DTPROGENTAFAUX = @V_DTPROGENTAF;

                     /* PEGA OS DADOS DA NOTA QUE FOI IMPORTADA PELA AF */
                     SELECT @V_TOTITM_VRDESC = SUM(VRATUAPAG)
                       FROM CONTAPAGAR
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND NRLANCTONF = @P_NRLANCTONF;

                     DECLARE C_DESCNOTA CURSOR FOR  /* PEGA AS AF'S RELACIONADAS  NOTA */
                        SELECT NRSEQVENPAG, VRORIGPAG, VRATUAPAG
                          FROM CONTAPAGAR
                         WHERE CDFILIAL   = @V_CDFILLANC
                           AND NRLANCTONF = @V_NRLANCTONF
                         ORDER BY DTORIGVENPAG
                     OPEN C_DESCNOTA;
                     FETCH NEXT FROM C_DESCNOTA INTO @V_NRSEQVENPAGDESC, @V_VRORIGPAGDESC, @V_VRATUAPAGDESC;

                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        IF (@V_TOTITM_VRDESC > 0) OR (@V_VRATUAPAGDESC <= 0) BEGIN
                           IF @V_VRATUAPAGDESC > @V_TOTITM_VRDESC BEGIN
                              SET @V_VRATUAPAGDESC = @V_VRATUAPAGDESC - @V_TOTITM_VRDESC;
                              SET @V_TOTITM_VRDESC = 0;
                           END
                           ELSE BEGIN
                              SET @V_TOTITM_VRDESC = @V_TOTITM_VRDESC - @V_VRATUAPAGDESC;
                              SET @V_VRATUAPAGDESC = 0;
                           END;
                        END;

                        /*############################ AJUSTE NA CONTA A PAGAR ###################################*/
                        UPDATE CONTAPAGAR
                           SET VRATUAPAG   = @V_VRATUAPAGDESC
                         WHERE CDFILIAL    = @V_CDFILLANC
                           AND NRLANCTONF  = @V_NRLANCTONF
                           AND NRSEQVENPAG = @V_NRSEQVENPAGDESC;

                        /*############################ CANCELA A NOTA FISCAL (SE NECESSARIO) #####################*/
                        /* SE CONTAPAGAR.VRATUAPAG <= 0 ENTAO CANCELA A NF*/
                        SELECT @V_VRATUAPAGAUX = SUM(CONTAPAGAR.VRATUAPAG)
                          FROM CONTAPAGAR
                         WHERE CONTAPAGAR.CDFILIAL   = @V_CDFILLANC
                           AND CONTAPAGAR.NRLANCTONF = @V_NRLANCTONF;

                        SET @V_COUNT = 0;

                        SELECT @V_COUNT = COUNT(1)
                          FROM AUTOFORNE AF, ITEMAUTF IT
                         WHERE AF.CDFILDEST = IT.CDFILDEST
                           AND AF.CDFILLANC = IT.CDFILLANC
                           AND AF.NRAUTOFORN = IT.NRAUTOFORN
                           AND AF.IDBAIXAAF <> '2'
                           AND IT.CDFILLANC = @V_CDFILLANC
                           AND IT.NRLANCTONF = @V_NRLANCTONF;

                        SET @V_IDSTATUSAUX = 'V';

                        IF @V_VRATUAPAGAUX <= 0.05 BEGIN
                           SET @V_IDSTATUSAUX = 'C';
                        END;

                        UPDATE NOTAFISCAL
                           SET IDSTATUS   = @V_IDSTATUSAUX
                         WHERE CDFILIAL   = @V_CDFILLANC
                           AND NRLANCTONF = @V_NRLANCTONF;

                        FETCH NEXT FROM C_DESCNOTA INTO @V_NRSEQVENPAGDESC, @V_VRORIGPAGDESC, @V_VRATUAPAGDESC;
                     END;
                     CLOSE C_DESCNOTA;
                     DEALLOCATE C_DESCNOTA;

                     FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;
                  END;
                  CLOSE C_NOTAPREVISTA;
                  DEALLOCATE C_NOTAPREVISTA;

                  FETCH NEXT FROM C_AUTOFORNE INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN;
               END;
               CLOSE C_AUTOFORNE;
               DEALLOCATE C_AUTOFORNE;

               /*###########################  MOVIMENTO DE FLUXO  #########################################*/
               DECLARE C_CONTAPAGAR CURSOR FOR
                  (SELECT CDEMPRESA,
                          DTMOVFLUXO,
                          IDMOVFLUXO,
                          CDCLASSFINA,
                          VRORIGPAG
                     FROM CONTAPAGAR
                    WHERE CDFILIAL   = @V_CDFILLANCAUX
                      AND NRLANCTONF = @V_NRLANCTONFAUX)
               OPEN C_CONTAPAGAR;
               FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA, @V_DTMOVFLUXO, @V_IDMOVFLUXO, @V_CDCLASSFINA, @V_VRORIGPAGFLUX;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  UPDATE MOVFLUXAF
                     SET VRPREVAF = VRPREVAF - @V_VRORIGPAGFLUX
                   WHERE CDFILDEST    = @V_CDFILDESTAUX
                     AND CDFILLANC    = @V_CDFILLANCAUX
                     AND NRAUTOFORN   = @V_NRAUTOFORNAUX
                     AND CDCLASSFINAF = @V_CDCLASSFINA
                     AND DTENTMOVAF   = @V_DTPROGENTAFAUX
                     AND DTPREVVENC   = @V_DTMOVFLUXO;

                  SET @V_VRORIGPAGAUX = @V_VRORIGPAGFLUX * -1;

                  EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                               @V_CDFILDESTAUX,
                                               @V_DTMOVFLUXO,
                                               @V_IDMOVFLUXO,
                                               @V_CDCLASSFINA,
                                               0,
                                               @V_VRORIGPAGAUX;

                  /*######################## ORCAMENTO FINANCEIRO ##########################################*/

                  SELECT @V_IDCONSORCFIN = IDCONSORCFIN,
                         @V_IDTPORCAFINA = IDTPORCAFINA
                    FROM PARAMGERAL;

                  IF (@V_IDCONSORCFIN = 'S') BEGIN
                     SET @V_CDFILIAL = NULL;
                     IF @V_IDTPORCAFINA = 'F' BEGIN
                        SET @V_CDFILIAL = @V_CDFILDEST;
                     END;

                     DECLARE C_ORCAFINA CURSOR FOR
                        SELECT CDEMPRESA,
                               CDFILIAL,
                               CDCLASSFINA,
                               CONVERT(VARCHAR, DTORCAFINA, 103)
                          FROM ORCAFINA
                         WHERE (CDEMPRESA   = @V_CDEMPRESA)
                           AND (CDFILIAL    = ISNULL(@V_CDFILIAL, CDFILIAL))
                           AND (CDCLASSFINA = @V_CDCLASSFINA)
                           AND (DTORCAFINA BETWEEN CONVERT(DATETIME, @V_DTMOVFLUXO) - DAY(CONVERT(DATETIME, @V_DTMOVFLUXO)) + 1
                                               AND DATEADD(MM,1, @V_DTMOVFLUXO)-DAY(@V_DTMOVFLUXO))

                     OPEN C_ORCAFINA;
                     FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;

                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        UPDATE ORCAFINA
                           SET VRREALORCA  = VRREALORCA - @V_VRORIGPAGFLUX
                         WHERE CDCLASSFINA = @V_CDCLASSFINAOF
                           AND CDEMPRESA   = @V_CDEMPRESAOF
                           AND CONVERT(VARCHAR, DTORCAFINA, 103) = @V_DTORCAFINAOF
                           AND CDFILIAL    = @V_CDFILIALOF;

                        FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;
                     END;
                     CLOSE C_ORCAFINA;
                     DEALLOCATE C_ORCAFINA;
                  END;
                  FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA, @V_DTMOVFLUXO, @V_IDMOVFLUXO, @V_CDCLASSFINA;
               END;
               CLOSE C_CONTAPAGAR;
               DEALLOCATE C_CONTAPAGAR;
            END;
         END
         ELSE BEGIN
            SELECT @V_IDGERCONTPGT = MAX(IDGERCONTPGT)
              FROM FORNECEDOR
             WHERE CDFORNECED = @V_CDFORNECED;

            IF @V_IDGERCONTPGT = 'S' BEGIN
               DECLARE C_AUTOFORNE CURSOR FOR  /* PEGA AS AF'S RELACIONADAS  NOTA */
                  SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN
                    FROM NFRELACAF
                   WHERE CDFILIAL   = @P_CDFILIAL
                     AND NRLANCTONF = @P_NRLANCTONF
               OPEN C_AUTOFORNE;
               FETCH NEXT FROM C_AUTOFORNE INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_CDFILLANCAUX  = @V_CDFILLANC;
                  SET @V_CDFILDESTAUX  = @V_CDFILDEST;
                  SET @V_NRAUTOFORNAUX = @V_NRAUTOFORN;

                  DECLARE C_NOTAPREVISTA CURSOR FOR   /* PEGA O NUMERO DE LANAMENTO DA CONTA PREVISTA */
                     SELECT DISTINCT NRLANCTONF, DTPROGENTAF
                       FROM ITEMAUTF
                      WHERE CDFILLANC  = @V_CDFILLANC
                        AND CDFILDEST  = @V_CDFILDEST
                        AND NRAUTOFORN = @V_NRAUTOFORN

                  OPEN C_NOTAPREVISTA;
                  FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;

                  SET @V_NRLANCTONFAUX  = @V_NRLANCTONF;
                  SET @V_DTPROGENTAFAUX = @V_DTPROGENTAF;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     /* PEGA OS DADOS DA NOTA QUE FOI IMPORTADA PELA AF */
                     SELECT @V_TOTITM_VRDESC = SUM(VRATUAPAG)
                       FROM CONTAPAGAR
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND NRLANCTONF = @P_NRLANCTONF;

                     SET @V_VALORDEVOLVIDO = @V_TOTITM_VRDESC;
                     SET @V_DIFERENCA = 0;

                     DECLARE C_DESCPREVISTA CURSOR FOR
                        SELECT VRORIGPAG, VRATUAPAG, NRSEQVENPAG
                          FROM CONTAPAGAR
                         WHERE CDFILIAL   = @V_CDFILLANC
                           AND NRLANCTONF = @V_NRLANCTONF
                         ORDER BY NRSEQVENPAG DESC

                     OPEN C_DESCPREVISTA;
                     FETCH NEXT FROM C_DESCPREVISTA INTO @V_VRORIGPAG, @V_VRATUAPAG, @V_NRSEQVENPAG;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        IF @V_VALORDEVOLVIDO >= 0 BEGIN
                           IF @V_VRATUAPAG <> @V_VRORIGPAG BEGIN
                              SET @V_DIFERENCA = @V_VRORIGPAG - @V_VRATUAPAG;

                              IF @V_DIFERENCA > @V_VALORDEVOLVIDO BEGIN
                                 UPDATE CONTAPAGAR
                                    SET VRATUAPAG   = @V_VRATUAPAG + @V_VALORDEVOLVIDO
                                  WHERE CDFILIAL    = @V_CDFILLANC
                                    AND NRLANCTONF  = @V_NRLANCTONF
                                    AND NRSEQVENPAG = @V_NRSEQVENPAG;
                              END
                              ELSE BEGIN
                                 UPDATE CONTAPAGAR
                                    SET VRATUAPAG   = @V_VRATUAPAG + @V_DIFERENCA
                                  WHERE CDFILIAL    = @V_CDFILLANC
                                    AND NRLANCTONF  = @V_NRLANCTONF
                                    AND NRSEQVENPAG = @V_NRSEQVENPAG;
                              END;

                              UPDATE NOTAFISCAL
                                 SET IDSTATUS   = 'V'
                               WHERE CDFILIAL   = @V_CDFILLANC
                                 AND NRLANCTONF = @V_NRLANCTONF;

                              SET @V_VALORDEVOLVIDO = @V_VALORDEVOLVIDO - @V_DIFERENCA;
                           END;
                        END;
                        FETCH NEXT FROM C_DESCPREVISTA INTO @V_VRORIGPAG, @V_VRATUAPAG, @V_NRSEQVENPAG;
                     END;
                     CLOSE C_DESCPREVISTA;
                     DEALLOCATE C_DESCPREVISTA;

                   FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;
                  END;
                  CLOSE C_NOTAPREVISTA;
                  DEALLOCATE C_NOTAPREVISTA;

                  FETCH NEXT FROM C_AUTOFORNE INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN;
               END;
               CLOSE C_AUTOFORNE;
               DEALLOCATE C_AUTOFORNE;

               /*########################### MOVIMENTO DE FLUXO #########################################*/
               DECLARE C_CONTAPAGAR CURSOR FOR
                  (SELECT CDEMPRESA,
                          DTMOVFLUXO,
                          IDMOVFLUXO,
                          CDCLASSFINA,
                          VRORIGPAG
                     FROM CONTAPAGAR
                    WHERE CDFILIAL   = @V_CDFILLANCAUX
                      AND NRLANCTONF = @V_NRLANCTONFAUX)
               OPEN C_CONTAPAGAR;
               FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA, @V_DTMOVFLUXO, @V_IDMOVFLUXO, @V_CDCLASSFINA, @V_VRORIGPAGFLUX;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  UPDATE MOVFLUXAF
                     SET VRPREVAF     = VRPREVAF + @V_VRORIGPAGFLUX
                   WHERE CDFILDEST    = @V_CDFILDESTAUX
                     AND CDFILLANC    = @V_CDFILLANCAUX
                     AND NRAUTOFORN   = @V_NRAUTOFORNAUX
                     AND CDCLASSFINAF = @V_CDCLASSFINA
                     AND DTENTMOVAF   = @V_DTPROGENTAFAUX
                     AND DTPREVVENC   = @V_DTMOVFLUXO;

                  EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                               @V_CDFILDESTAUX,
                                               @V_DTMOVFLUXO,
                                               @V_IDMOVFLUXO,
                                               @V_CDCLASSFINA,
                                               0,
                                               @V_VRORIGPAGFLUX;

                  /*######################## ORCAMENTO FINANCEIRO ##########################################*/

                  SELECT @V_IDCONSORCFIN = IDCONSORCFIN,
                         @V_IDTPORCAFINA = IDTPORCAFINA
                    FROM PARAMGERAL;

                  IF (@V_IDCONSORCFIN = 'S') BEGIN
                     SET @V_CDFILIAL = NULL;
                     IF @V_IDTPORCAFINA = 'F' BEGIN
                        SET @V_CDFILIAL = @V_CDFILDEST;
                     END;

                     DECLARE C_ORCAFINA CURSOR FOR
                        SELECT CDEMPRESA,
                               CDFILIAL,
                               CDCLASSFINA,
                               CONVERT(VARCHAR, DTORCAFINA, 103)
                          FROM ORCAFINA
                         WHERE (CDEMPRESA   = @V_CDEMPRESA)
                           AND (CDFILIAL    = ISNULL(@V_CDFILIAL, CDFILIAL))
                           AND (CDCLASSFINA = @V_CDCLASSFINA)
                           AND (DTORCAFINA BETWEEN CONVERT(DATETIME, @V_DTMOVFLUXO) - DAY(CONVERT(DATETIME, @V_DTMOVFLUXO)) + 1
                                               AND DATEADD(MM,1, @V_DTMOVFLUXO)-DAY(@V_DTMOVFLUXO))

                     OPEN C_ORCAFINA;
                     FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;

                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        UPDATE ORCAFINA
                           SET VRREALORCA  = VRREALORCA + @V_VRORIGPAGFLUX
                         WHERE CDCLASSFINA = @V_CDCLASSFINAOF
                           AND CDEMPRESA   = @V_CDEMPRESAOF
                           AND CONVERT(VARCHAR, DTORCAFINA, 103) = @V_DTORCAFINAOF
                           AND CDFILIAL    = @V_CDFILIALOF;

                        FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;
                     END;
                     CLOSE C_ORCAFINA;
                     DEALLOCATE C_ORCAFINA;
                  END;
                  FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA, @V_DTMOVFLUXO, @V_IDMOVFLUXO, @V_CDCLASSFINA;
               END;
               CLOSE C_CONTAPAGAR;
               DEALLOCATE C_CONTAPAGAR;
            END;
         END;
      END;
      FETCH NEXT FROM C_NOTAREAL INTO @V_IDENTRSAIDOP, @V_CDFORNECED;
   END;
   CLOSE C_NOTAREAL;
   DEALLOCATE C_NOTAREAL;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'AJUSTE_CONTAPAGAR_NF','5.65.xxx';
GO
